#!/usr/bin/ruby

module GClouderUndefinedResources
  class LocalResources
    extend Forwardable

    def initialize(file)
      @resources = yaml_load(file)
    end

    def_delegator :@resources, :[]

    def yaml_load(file)
      @resources = YAML.load_file(file)
    rescue => e
      puts "failed to load local resource file: #{e}"
      exit 1
    end

    def global?(key, name)
      return false if key.empty?
      #ap @resources
      #puts "looking up: #{key}, name: #{name}"
      match = @resources.dig(*key)
      return false if match.nil?
      found_resources = match.select { |hash| hash["name"] == name }
      !found_resources.empty?
    #rescue => error
    #  puts "#{error}: #{key}:#{name}"
    #  exit 1
    end

    def regional?(region, key, name)
      return false if key.empty?
      #ap @resources
      #puts "looking up: #{key}, name: #{name}"
      match = @resources.dig("regions", region, *key)
      return false if match.nil?
      found_resources = match.select { |hash| hash["name"] == name }
      !found_resources.empty?
    #rescue => error
    #  puts "#{error}: #{key}:#{name}"
    #  exit 1
    end
  end
end
