#!/usr/bin/env ruby

module GClouderUndefinedResources
  module Resource
    def self.local=(file)
      @local_resources = YAML.load_file(file)
    rescue => e
      raise StandardError, "failed to load local resource file: #{e}"
    end

    def self.local
      @local_resources
    end

    def self.global?(key, name)
      resources = local.dig(*key)
      return false if resources.nil?
      found_resources = resources.select { |hash| hash["name"] == name }
      !found_resources.empty?
    end

    def self.regional?(region, key, name)
      resources = local.dig("regions", region, *key)
      return false if resources.nil?
      found_resources = resources.select { |hash| hash["name"] == name }
      !found_resources.empty?
    end
  end
end
